/*
Copyright (C) 2011 Craciun Dan <craciun.dan@tuxarena.com>

This file is part of NeonView.

NeonView is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 2 of the License, or
(at your option) any later version.

NeonView is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with NeonView.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "header.h"

void put_image (TM *tm) {
	if (tm->image != NULL && tm->pixbuf != NULL) {
		gtk_widget_destroy(tm->image);
	}

	tm->pixbuf = gdk_pixbuf_new_from_file(tm->tfd->disp, NULL);
	if (tm->pixbuf == NULL) {
		//		fprintf(stdout, "Could not read file %s\n", tm->tfd->disp);
		gtk_label_set_text(GTK_LABEL(tm->label1), "Could not load image");
		gtk_label_set_text(GTK_LABEL(tm->label2), "");
		gtk_label_set_text(GTK_LABEL(tm->label3), "");
		gtk_label_set_text(GTK_LABEL(tm->label4), "");
		tm->tfi->loaded = 0;
		return;
	}
	tm->image = gtk_image_new_from_pixbuf(tm->pixbuf);
	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->scrolled), tm->image);
	gtk_widget_show_all(tm->scrolled);

	/*--- get the image info ---*/

	/* label1 - basename */
	gtk_label_set_text(GTK_LABEL(tm->label1), tm->tfd->basename);

	/* label2 - size in pixels */
	if (GDK_IS_PIXBUF(tm->pixbuf) != 0) {
		tm->tfi->width = gdk_pixbuf_get_width(tm->pixbuf);
		tm->tfi->height = gdk_pixbuf_get_height(tm->pixbuf);
		tm->tfi->new_width = tm->tfi->width;
		tm->tfi->new_height = tm->tfi->height;

		tm->tfi->loaded = 1;

		char tmp[257], str[257];
		int2str(tm->tfi->width, tmp);
		strcpy(str, tmp);
		strcat(str, "x");
		int2str(tm->tfi->height, tmp);
		strcat(str, tmp);

		gtk_label_set_text(GTK_LABEL(tm->label2), str);
	}

	/* label3 - size in bytes */
	FILE *fd;
	int filesize;
	char tmp[257], rmd[257], rmd2[257];
	int remainder;

	fd = fopen(tm->tfd->disp, "rb");
	fseek(fd, 0, SEEK_END);
	filesize = ftell(fd); // size in bytes
	fseek(fd, 0, SEEK_SET);
	fclose(fd);

	if (filesize < 1024) {
		int2str(filesize, tmp);
		strcat(tmp, " bytes");
	} else if (filesize >= 1024 && filesize < 1024 * 1024) {
		remainder = filesize % 1024;
		filesize = filesize / 1024;
		int2str(filesize, tmp);
		strcat(tmp, ".");
		int2str(remainder, rmd);
		if (strlen(rmd) > 2) {
		rmd2[0] = rmd[0]; rmd2[1] = rmd[1]; rmd2[2] = '\0';
		strcat(tmp, rmd2);
		} else {
			strcat(tmp, rmd);
		}
		strcat(tmp, " KB");
	} else if (filesize >= 1024 * 1024 && filesize <= 1024 * 1024 * 1024) {
		remainder = filesize % (1024 * 1024);
		filesize = filesize / (1024 * 1024);
		int2str(filesize, tmp);
		strcat(tmp, ".");
		int2str(remainder, rmd);
		if (strlen(rmd) > 2) {
		rmd2[0] = rmd[0]; rmd2[1] = rmd[1]; rmd2[2] = '\0';
		strcat(tmp, rmd2);
		} else {
			strcat(tmp, rmd);
		}
		strcat(tmp, " MB");
	}

	gtk_label_set_text(GTK_LABEL(tm->label3), tmp);

	/* label4 - format */
	if (check_ext(tm->tfd->disp) == 1) {
		gtk_label_set_text(GTK_LABEL(tm->label4), "JPG image");
	}
	if (check_ext(tm->tfd->disp) == 2) {
		gtk_label_set_text(GTK_LABEL(tm->label4), "PNG image");
	}
	if (check_ext(tm->tfd->disp) == 3) {
		gtk_label_set_text(GTK_LABEL(tm->label4), "TIFF image");
	}
	if (check_ext(tm->tfd->disp) == 4) {
		gtk_label_set_text(GTK_LABEL(tm->label4), "SVG image");
	}
	if (check_ext(tm->tfd->disp) == 5) {
		gtk_label_set_text(GTK_LABEL(tm->label4), "XCF image");
	}
	if (check_ext(tm->tfd->disp) == 6) {
		gtk_label_set_text(GTK_LABEL(tm->label4), "PBM image");
	}
	if (check_ext(tm->tfd->disp) == 7) {
		gtk_label_set_text(GTK_LABEL(tm->label4), "BMP image");
	}
	if (check_ext(tm->tfd->disp) == 8) {
		gtk_label_set_text(GTK_LABEL(tm->label4), "GIF image");
	}
	if (check_ext(tm->tfd->disp) == 9) {
		gtk_label_set_text(GTK_LABEL(tm->label4), "PNM image");
	}
	if (check_ext(tm->tfd->disp) == 10) {
		gtk_label_set_text(GTK_LABEL(tm->label4), "PGM image");
	}
	if (check_ext(tm->tfd->disp) == 11) {
		gtk_label_set_text(GTK_LABEL(tm->label4), "XPM image");
	}
	if (check_ext(tm->tfd->disp) == 12) {
		gtk_label_set_text(GTK_LABEL(tm->label4), "TGA image");
	}
	if (check_ext(tm->tfd->disp) == 13) {
		gtk_label_set_text(GTK_LABEL(tm->label4), "PPM image");
	}
}
