/*
  Copyright (C) 2011 Craciun Dan <craciun.dan@tuxarena.com>

  This file is part of NeonView.

  NeonView is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 2 of the License, or
  (at your option) any later version.

  NeonView is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with NeonView.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "header.h"

int list_files (TM *tm) {
	DIR *dir;

	tm->tfd->total = 0;

	dir = opendir(tm->tfd->listd);
	if (dir != NULL) {
		struct dirent *ent;
		while ((ent = readdir(dir)) != NULL) {
			if (check_ext(ent->d_name) != 0) {
				(tm->tfd->total)++;
			}
		}
		closedir(dir);
	} else {
		fprintf(stderr, "ERROR: Could not open directory %s.\n", tm->tfd->listd);
		return -1;
	}

	tm->tfd->files = malloc(tm->tfd->total * sizeof(char*));
	if (!tm->tfd->files) {
		put_error(11);
	}

	dir = opendir(tm->tfd->listd);
	if (dir != NULL) {
		struct dirent *ent;
		char tmp[4097]; /* or more? */
		int i = 0;

		while ((ent = readdir(dir)) != NULL) {
			if (check_ext(ent->d_name) != 0) {
				tm->tfd->files[i] = malloc(4097 * sizeof(char));
				if (!tm->tfd->files[i]) {
					put_error(11);
				}

				strcpy(tmp, tm->tfd->listd);
				strcat(tmp, "/");
				strcat(tmp, ent->d_name);
				strcpy(tm->tfd->files[i], tmp);

				i++;
			}
		}
		closedir(dir);
	} else {
		fprintf(stderr, "ERROR: Could not open directory.\n");
		return -1;
	}

	return 0;
}

int check_ext (char name[4097]) {
#ifdef COMMENT
	char charlist[100][6] ={".jpg", ".png", ".tif", ".svg", "pbm", "xcf", "bmp"};
	int i = 0;
	int isimg = 0;
	int stop = 0, save = 0;

	while (i < 7 && stop == 0) {
		if (name[strlen(name)-1] == charlist[i][3] &&
			name[strlen(name)-2] == charlist[i][2] &&
			name[strlen(name)-3] == charlist[i][1] &&
			name[strlen(name)-4] == charlist[i][0]) {
			isimg = 1; stop = 1;
			save = i;
			//printf("save = %d\n", save);
		}
		i++;
	}

	//printf("name = '%s'\n", name);

	if (isimg == 1) {
		//charlist[save][4] = '\0';
		//		lc(charlist[save]);
		//		printf("charlist = '%s'\n", charlist[save]);

		if (strcmp(charlist[save], ".bmp") == 0) { return 7; }
		if (strcmp(charlist[save], ".jpg") == 0) { return 1; }
		if (strcmp(charlist[save], ".png") == 0) { return 2; }
		printf("abc charlist = %s\n", charlist[save]);
		if (strcmp(charlist[save], ".tif") == 0) { return 3; }
		if (strcmp(charlist[save], ".svg") == 0) { return 4; }
		if (strcmp(charlist[save], ".pbm") == 0) { return 5; }
		if (strcmp(charlist[save], ".xcf") == 0) { return 6; }

	}
#endif


	char tmp[4097];
	strcpy(tmp, name);
	lc(tmp);

	if (tmp[strlen(tmp)-1] == 'p' &&
		tmp[strlen(tmp)-2] == 'm' &&
		tmp[strlen(tmp)-3] == 'b' &&
		tmp[strlen(tmp)-4] == '.') {
		return 7;
	}
	/*
	if (tmp[strlen(tmp)-1] == 'f' &&
		tmp[strlen(tmp)-2] == 'c' &&
		tmp[strlen(tmp)-3] == 'x' &&
		tmp[strlen(tmp)-4] == '.') {
		return 6;
	}
	*/
	if (tmp[strlen(tmp)-1] == 'm' &&
		tmp[strlen(tmp)-2] == 'b' &&
		tmp[strlen(tmp)-3] == 'p' &&
		tmp[strlen(tmp)-4] == '.') {
		return 5;
	}
	if (tmp[strlen(tmp)-1] == 'f' &&
		tmp[strlen(tmp)-2] == 'i' &&
		tmp[strlen(tmp)-3] == 'g' &&
		tmp[strlen(tmp)-4] == '.') {
		return 8;
	}
	if (tmp[strlen(tmp)-1] == 'm' &&
		tmp[strlen(tmp)-2] == 'n' &&
		tmp[strlen(tmp)-3] == 'p' &&
		tmp[strlen(tmp)-4] == '.') {
		return 9;
	}
	if (tmp[strlen(tmp)-1] == 'm' &&
		tmp[strlen(tmp)-2] == 'g' &&
		tmp[strlen(tmp)-3] == 'p' &&
		tmp[strlen(tmp)-4] == '.') {
		return 10;
	}
	if (tmp[strlen(tmp)-1] == 'm' &&
		tmp[strlen(tmp)-2] == 'p' &&
		tmp[strlen(tmp)-3] == 'x' &&
		tmp[strlen(tmp)-4] == '.') {
		return 11;
	}
	if (tmp[strlen(tmp)-1] == 'a' &&
		tmp[strlen(tmp)-2] == 'g' &&
		tmp[strlen(tmp)-3] == 't' &&
		tmp[strlen(tmp)-4] == '.') {
		return 12;
	}
	if (tmp[strlen(tmp)-1] == 'm' &&
		tmp[strlen(tmp)-2] == 'p' &&
		tmp[strlen(tmp)-3] == 'p' &&
		tmp[strlen(tmp)-4] == '.') {
		return 13;
	}

	  if (name[strlen(name)-1] == 'g' &&
	  name[strlen(name)-2] == 'p' &&
	  name[strlen(name)-3] == 'j' &&
	  name[strlen(name)-4] == '.') {
	  return 1;
	  }
	  if (name[strlen(name)-1] == 'g' &&
	  name[strlen(name)-2] == 'n' &&
	  name[strlen(name)-3] == 'p' &&
	  name[strlen(name)-4] == '.') {
	  return 2;
	  }
	  if (name[strlen(name)-1] == 'G' &&
	  name[strlen(name)-2] == 'N' &&
	  name[strlen(name)-3] == 'P' &&
	  name[strlen(name)-4] == '.') {
	  return 3;
	  }
	  if (name[strlen(name)-1] == 'G' &&
	  name[strlen(name)-2] == 'P' &&
	  name[strlen(name)-3] == 'J' &&
	  name[strlen(name)-4] == '.') {
	  return 4;
	  }

	//lc(name);
	  if (name[strlen(name)-1] == 'g' &&
	  name[strlen(name)-2] == 'e' &&
	  name[strlen(name)-3] == 'p' &&
	  name[strlen(name)-4] == 'j' &&
	  name[strlen(name)-5] == '.') {
	  return 1;
	  }
	  if (name[strlen(name)-1] == 'f' &&
	  name[strlen(name)-2] == 'f' &&
	  name[strlen(name)-3] == 'i' &&
	  name[strlen(name)-4] == 't' &&
	  name[strlen(name)-5] == '.') {
	  return 3;
	  }

	return 0;
}

void sort_files (TM *tm) {
	int i;
	char tmp[4097];
	int change = 1;

	while (change == 1) {
		change = 0;
		for (i = 0; i < tm->tfd->total; i++) {
			if (i < tm->tfd->total - 1) {
				if (strcmp(tm->tfd->files[i], tm->tfd->files[i+1]) > 0) {
					change = 1;
					strcpy(tmp, tm->tfd->files[i]);
					strcpy(tm->tfd->files[i], tm->tfd->files[i+1]);
					strcpy(tm->tfd->files[i+1], tmp);
				}
			}
		}
	}
}

void lc (char *str) {
	int i;

	for (i = 0; i < strlen(str); i++) {
		if (str[i] >= 65 && str[i] <= 90) {
			str[i] = str[i] + 32;
		}
	}
	str[i] = '\0';
}

void int2str (long n, char *str) {
	int q, r; /* quotient, remainder */
	int i = 0;
	int isn = 0; /* is negative */

	if (n < 0) {
		n = n * -1;
		isn = 1;
	}
	while (n > 0) {
		q = n / 10;
		r = n % 10;
		n = n / 10;
		str[i] = r + 48; /* ascii to character */
		i++;
	}
	if (isn == 0) {
		str[i] = '\0';
	} else {
		str[i] = '-';
		str[i+1] = '\0';
	}
	rts(str);
}

/* reverse string */
void rts (char *str) {
	int len;
	int i;
	char tmp;

	len = strlen(str) - 1;
	for (i = 0; i < strlen(str) / 2; i++) {
		tmp = str[len];
		str[len] = str[i];
		str[i] = tmp;
		len--;
	}
}
